#!/bin/bash

PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
export PATH

TITLE="BLUETOOTH PIN"

umask 077

TMP="/tmp/btpin.$$"

PIN=""

X="$(/bin/ps --format args --no-headers -C X -C XFree86 2>/dev/null)"

XAUTHORITY=""
DISPLAY=""

if [ -n "$X" ]; then
 DISPLAY=":0"
 authfile=""
 for i in $X; do
  [ -n "$authfile" ] && export XAUTHORITY="$i"
  case "$i" in :*) export DISPLAY="$i" ;; -auth) authfile="true"; continue ;; esac
  authfile=""
 done
fi

rm -f "$TMP"

if [ -n "$DISPLAY" ]; then
DIALOG=Xdialog
$DIALOG --title "$TITLE" --insecure --passwordbox "$TITLE" 8 35 2>"$TMP"
else
DIALOG=dialog
chvt 12
$DIALOG --stdout --title "$TITLE" --insecure --passwordbox "$TITLE" 8 35 >"$TMP" 2>/dev/tty12 </dev/tty12
chvt 1
fi

PIN="$(cat $TMP)"
rm -f "$TMP"

[ -n "$PIN" ] && echo "PIN:$PIN" || echo "ERR"
